let is_between lower upper c =
 lower <= c && c <= upper

let is_in list c = List.mem c list

let is_lowercase = is_between 'a' 'z'
let is_uppercase = is_between 'A' 'Z'
let is_figure = is_between '0' '9'

let is_letter c = is_lowercase c || is_uppercase c
let is_alphanumeric c = is_letter c || is_figure c
let is_identifier_char c =
  is_alphanumeric c || is_in ['\''; '_'] c

let is_infix_symbol =
 is_in ['='; '<'; '>'; '@'; '^'; '|'; '&'; '+'; '-'; '*'; '/'; '$'; '%']

let is_operator_symbol =
 is_in
   ['!'; '$'; '%'; '&'; '*'; '+'; '-';
    '.'; '/'; ':'; '<'; '='; '>'; '?';
    '@'; '^'; '|'; '~'; '#']

let must_be_followed_symbol =
  is_in ['#'; '?'; '~']

let is_prefix_symbol =
  is_in ['~'; '?'; '!']

let is_white =
  is_in ['\t'; ' '; '\r'; '\n']

let is_endline =
  is_in ['\n']
