let map option ~f =
  match option with
  | Some elt -> Some (f elt )
  | None -> None

let bind option ~f =
  match option with
  | Some elt -> f elt
  | None -> None

let (>|=) option f = map option ~f
let (>>=) option f = bind option ~f

let return elt = Some elt

let value option ~default =
  match option with
  | Some elt -> elt
  | None -> default


let or_else option1 option2 =
  if option1 = None then option2
  else option1

let (<|>) = or_else 
